﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGHierarchicalData
{
    public class ParentDataModel : ObservableModel
    {
        private int _id { get; set; }
        private string _name { get; set; }
        private ObservableCollection<ChildDataModel> _children { get; set; }

        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                NotifyPropertyChanged();
            }
        }
        public int Id
        {
            get { return _id; }
            set
            {
                _id = value;
                NotifyPropertyChanged();
            }
        }

        public ObservableCollection<ChildDataModel> Children
        {
            get { return _children; }
            set
            {
                _children = value;
                NotifyPropertyChanged();
            }
        }
    }

    public class ChildDataModel : ObservableModel
    {
        private int _childId { get; set; }
        private string _childName { get; set; }
        private ObservableCollection<GrandChildDataModel> _children { get; set; }

        public string ChildName
        {
            get { return _childName; }
            set
            {
                _childName = value;
                NotifyPropertyChanged();
            }
        }
        public int ChildId
        {
            get { return _childId; }
            set
            {
                _childId = value;
                NotifyPropertyChanged();
            }
        }
        public ObservableCollection<GrandChildDataModel> Children
        {
            get { return _children; }
            set
            {
                _children = value;
                NotifyPropertyChanged();
            }
        }
    }

    public class GrandChildDataModel : ObservableModel
    {
        private int _grandChildId { get; set; }
        private string _grandChildName { get; set; }


        public string GrandChildName
        {
            get { return _grandChildName; }
            set
            {
                _grandChildName = value;
                NotifyPropertyChanged();
            }
        }
        public int GrandChildId
        {
            get { return _grandChildId; }
            set
            {
                _grandChildId = value;
                NotifyPropertyChanged();
            }
        }
    }
}
