﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static System.Windows.Forms.VisualStyles.VisualStyleElement.TextBox;

namespace XDGHierarchicalData
{
    public class ViewModel : ObservableModel
    {
        private ObservableCollection<ParentDataModel> _data;
        private Random rnd;

        public ObservableCollection<ParentDataModel> Data
        {
            get
            {
                return _data;
            }
            set
            {
                _data = value;
                NotifyPropertyChanged();
            }
        }

        public ViewModel()
        {
            rnd = new Random();
            this.Data = new ObservableCollection<ParentDataModel>();

            for (int i = 0; i < 100; i++)
            {
                ParentDataModel p = new ParentDataModel() { Id = i, Name = "Parent " + i };

                if (i % 6 == 0)
                {
                    // no children
                    Data.Add(p);
                    continue;
                }
                p.Children = new ObservableCollection<ChildDataModel>();  

                for (int j = 0; j < 8; j++)
                {
                    ChildDataModel child = new ChildDataModel() { ChildId = j, ChildName = "Child " + j };

                    if(j % 2 == 0)
                    {
                        // no grand children
                        p.Children.Add(child);
                        continue;
                    }
                    child.Children = new ObservableCollection<GrandChildDataModel>();


                    for (int k = 0; k < 5; k++)
                    {
                        GrandChildDataModel grandChild = new GrandChildDataModel() { GrandChildId = k, GrandChildName = "CrandChild " + k };
                        child.Children.Add(grandChild);
                    }
                    p.Children.Add(child);
                }
                Data.Add(p);
            }
        }
    }
}
